Tinykos = LibStub("AceAddon-3.0"):NewAddon("TinyKoS","AceEvent-3.0","AceConsole-3.0")

local Tinykos, self = Tinykos, Tinykos

local active = true

local sm = LibStub("LibSharedMedia-3.0")
local sink = LibStub("LibSink-2.0")
sink:Embed(self)

self.db = nil

local L = LibStub("AceLocale-3.0"):GetLocale("TinyKoS")

local spottedList = {}
-- {
--   ["dummyplayer"] = {
--     lastwarning = 800
--     lastspotted = 1000
--   }
-- }

function Tinykos:OnInitialize()
	sm:Register("sound", "Murloc", "Interface\\AddOns\\TinyKoS\\sounds\\murloc.mp3")
	
	local defaults = {
		["profile"] = {
			["sink"] = {
				["sind20OutputSink"] = "Default",
				["sink20Sticky"] = true,
			},
			["hide"] = {
				["friendly"] = true,
				["contested"] = true,
				["hostile"] = true,
				["sanctuary"] = false,
				["combat"] = true,
				["_nil"] = false,
			},
			["sound"] = "Murloc",
			["warningInterval"] = 25,
		},
		["realm"] = {
			["watchlist"] = {},
		},
	}
	
	self.db = LibStub("AceDB-3.0"):New("TinykosDB", defaults)
	
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	
	if GetZonePVPInfo() ~= "sanctuary" then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
	
-- 	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")

	self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
	
	self:SetSinkStorage(self.db.profile.sink)
	self:RegisterSink("TinyKoS", "TinyKoS", nil, "Print")
	
	self:InitOptions()
	
	self:RegisterChatCommand("tinykos", "ShowConfig")

end

function Tinykos:PLAYER_ENTERING_WORLD()
	self:ZONE_CHANGED_NEW_AREA()
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
end

function Tinykos:ZONE_CHANGED_NEW_AREA()

	local zone_type = GetZonePVPInfo()
	
	if not zone_type then
		zone_type = "_nil"
	end
	
	if self.db.profile.hide[zone_type] then
		if active then
			self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			active = false
		end
	else
		if not active then
			self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
			active = true
		end
	end
	
end

--function Tinykos:slashcmd()
--	if not input or input == "" or input == " " then
--		self:Print("Usage: /tinykos <name> <reason>")
--	else
--		local fp = input:find(" ");
--		local name
--		local reason
--		if fp then
--		name = input:sub(0,fp-1)
--		reason = input:sub(fp+1,-1)
--		else
--		name = input
--		reason = "unknown"
--		end
--		self:AddToList(name, reason)
--		self:buildOptions()
--	end
--end

local function printwarning(name, data)
	
	self:Pour(string.format(L["%s spotted (%s)"],name, data.reason))
	
	local sound = sm:Fetch('sound', self.db.profile.sound)
	PlaySoundFile(sound)
	
end

-- function Tinykos:UPDATE_MOUSEOVER_UNIT()
--   local unit = UnitName("mouseover")
--   
--   if self.db.realm.watchlist[unit] then
--   
--   end
--   
-- end

function Tinykos:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
  
  local k, v
	
		if spottedList[srcName] then
		k = srcName
		v = self.db.realm.watchlist[srcName]
	elseif spottedList[dstName] then
		k = dstName
		v = self.db.realm.watchlist[dstName]
	end
	
	if k and v then
		spottedList[k].lastspotted = timestamp
		if (timestamp - spottedList[k].lastwarning) > self.db.profile.warningInterval then
			printwarning(k,v)
			spottedList[k].lastwarning = timestamp
		end
		return
	end
	
	if self.db.realm.watchlist[srcName] then
		k = srcName
		v = self.db.realm.watchlist[srcName]
	elseif self.db.realm.watchlist[dstName] then
		k = dstName
		v = self.db.realm.watchlist[dstName]    
	else
		return
	end
	
	spottedList[k] = {
		lastwarning = timestamp,
		lastspotted = timestamp,
	}
	printwarning(k,v)
 
end

function Tinykos:AddToList(playerName, reason)
	self.db.realm.watchlist[playerName]={["reason"] = reason or "",}
end

function Tinykos:RemoveFromList(playerName)
	self.db.realm.watchlist[playerName] = nil
	if spottedList[playerName] then
		spottedList[playerName] = nil
	end
end
